// Code generated by mockery v2.53.0. DO NOT EDIT.

package activityevent

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	db "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/db"

	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockService is an autogenerated mock type for the Service type
type MockService struct {
	mock.Mock
}

// CreateActivityEvent provides a mock function with given fields: ctx, input
func (_m *MockService) CreateActivityEvent(ctx context.Context, input *CreateActivityEventInput) (*models.ActivityEvent, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateActivityEvent")
	}

	var r0 *models.ActivityEvent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreateActivityEventInput) (*models.ActivityEvent, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreateActivityEventInput) *models.ActivityEvent); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ActivityEvent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreateActivityEventInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetActivityEvents provides a mock function with given fields: ctx, input
func (_m *MockService) GetActivityEvents(ctx context.Context, input *GetActivityEventsInput) (*db.ActivityEventsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetActivityEvents")
	}

	var r0 *db.ActivityEventsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetActivityEventsInput) (*db.ActivityEventsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetActivityEventsInput) *db.ActivityEventsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*db.ActivityEventsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetActivityEventsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SubscribeToActivityEvents provides a mock function with given fields: ctx, input
func (_m *MockService) SubscribeToActivityEvents(ctx context.Context, input *SubscribeToActivityEventsInput) (<-chan *models.ActivityEvent, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for SubscribeToActivityEvents")
	}

	var r0 <-chan *models.ActivityEvent
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *SubscribeToActivityEventsInput) (<-chan *models.ActivityEvent, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *SubscribeToActivityEventsInput) <-chan *models.ActivityEvent); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(<-chan *models.ActivityEvent)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *SubscribeToActivityEventsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockService creates a new instance of MockService. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockService(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockService {
	mock := &MockService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
